#ifndef _WEBFLOW_ 
#include "../BC.idl"
#endif 

module WebFlow 
{
  module RemoteFile2 
  {
    interface RemoteFile2 : BeanContextChild
    {
      /*
	delete, rename, copy
	mkdir, rmdir
      */
      
      typedef sequence<octet> octet_sequence;
      exception FileException { string message; };
      exception EOFFileException {};
      
      void open(in string file_name, in string options) 
	raises( FileException );
      void open_file1 (in string file_name, in string options)
	raises( FileException );	
      void open_file2 (in string file_name, in string options)
	raises( FileException );
      void open_file3 (in string file_name, in string options)
	raises( FileException );

      void close();
      void close_file1();
      void close_file2();
      void close_file3();

      octet_sequence  getBlock()  
	raises( FileException, EOFFileException);
      octet_sequence  getBlock_file1()  
	raises( FileException, EOFFileException);
      octet_sequence  getBlock_file2()  
	raises( FileException, EOFFileException);
      octet_sequence  getBlock_file3()  
	raises( FileException, EOFFileException);      

      void get(out octet c) 
	raises( FileException, EOFFileException );
      void putBlock(in octet_sequence arr)  
	raises( FileException );
      void put(in octet c) raises( FileException );
      void setBlockSize(in short aSize);

      long getFileSize() raises( FileException );
      long getFileSize_file1() raises( FileException );
      long getFileSize_file2() raises( FileException );
      long getFileSize_file3() raises( FileException );

      boolean delete(in string file_name);
      boolean mkdir(in string dir_name);
      boolean rmdir(in string dir_name);
      boolean rename(in string source, in string dest);
      boolean copy(in string source, in string dest);
      boolean exists(in string file_name);
      void saveIOR(in string ir, in string fileName);
      boolean saveAsFile(in string filename, in string body);
      void test();
    };

    interface MoveFile2:BeanContextChild
    {
      void Init(in RemoteFile2 remote_file);
      void FileReceive(in string dest, in string source);
      void FileSend(in string dest, in string source);
    };
  };
};




